/**************************************************************************************************/

/*
 * File: main.c
 * Author: Roman Lysecky
 * Date Created: 18 September 2012
 *
 * Description: Main functionality for simple C program that constructs a list of user entered 
 *              strings and prints the list.
 *
 * Copyright: Roman Lysecky, Electrical and Computer Engineering, University of Arizona, 2012.
 *
 */

/**************************************************************************************************/

#include "bool.h"
#include "listelmt.h"
#include "list.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/**************************************************************************************************/

#define BUFSIZE 1000

/**************************************************************************************************/

int
main() 
{
   char userInput[BUFSIZE];
   char *newStr;
   List word_list;
   ListElmt *list_iter;
   
   list_init(&word_list);
   
   printf("Enter a new string (or \"Done\" when finished): ");
   fgets(userInput, BUFSIZE, stdin);
   
   while ( strcmp(userInput, "Done\n") != 0 ) {
      // malloc new list data (string)
      newStr = (char *)malloc(strlen(userInput)+1);
      if (newStr == NULL) break;

      strcpy(newStr, userInput);

      list_ins_next(&word_list, word_list.tail, newStr);
      printf("Enter a new string (or \"Done\" when finished): ");
      fgets(userInput, BUFSIZE, stdin);
   }
   
   list_iter = list_head(&word_list);
   while(list_iter != NULL) {
      printf("%s", list_iter->str);
      list_iter = list_next(list_iter);
   }
   
   list_destroy(&word_list);
   
   return 0;
}

/**************************************************************************************************/
